local bitser = require("libraries/bitser")

Game = require("libraries/classic"):extend()

bitser:registerClass(Schema)

function Game:new(schema)
    self.schema = nil
    self.file_name = nil
    self.gui = Gui(self)

    self:set_schema(schema)
end

function Game:set_schema(schema)
    if schema == nil then
        self.schema = Schema()
        self.schema:add_node(EmitterNode(640, 100, self.schema))
        self.schema:add_node(ScreenNode(640, 620, self.schema))
        self.schema:connect(self.schema.nodes[1], self.schema.nodes[2])
    else
        self.schema = schema
    end
end

function Game:load_schema(file_name)
    self.schema = bitser:loadLoveFile(file_name)
end

function Game:save_schema(file_name)
    bitser:dumpLoveFile(file_name or self.file_name, self.schema)
end

function Game:update()
    self.schema:update()

    self.gui:update()
end

function Game:draw()
    self.schema:draw()

    self.gui:draw()
end