local array = {}

function array.index_of(t, value, start_index, comparator)
    local found = false
    local index = nil
    local tlen = #t
    start_index = start_index or 1

    for i = start_index, tlen do
        local current = t[i]

        if not found then
            if comparator then
                found = comparator(current, value)
            else
                found = value == current
            end
            if found then
                index = i
            end
        end
    end

    return index
end

function array.find(t, value, start_index, comparator)
    local index = array.index_of(t, value, start_index, comparator)

    return index and t[index]
end

return array