local enum = {}

local enum_mt = {
    __call = function(self, argument, value)
        if value ~= nil and self[value] == nil then error(('accepted values for %s are {%s}'):format(argument, table.concat(self, ', '))) end
    end
}

local function new(_, ...)
    local e = {...}
    for i = 1, select('#',...) do
        e[select(i, ...)] = i
    end
    setmetatable(e, enum_mt)
    return e
end

setmetatable(enum, {
    __call = new
})

return enum