local flag = {}

-- This function takes in a number and returns its binary form as a string
local function to_binary(num)
	local bin = num == 0 and "0" or ""  -- Create an empty string to store the binary form
	local rem  -- Declare a variable to store the remainder

	-- This loop iterates over the number, dividing it by 2 and storing the remainder each time
	-- It stops when the number has been divided down to 0
	while num > 0 do
		rem = num % 2  -- Get the remainder of the division
		bin = rem .. bin  -- Add the remainder to the string (in front, since we're iterating backwards)
		num = math.floor(num *0.5)  -- Divide the number by 2
	end

	return bin  -- Return the string
end

function flag.get_bit(flag_accumulator, flag_bit_decimal)
    local flag_bit_pos = to_binary(flag_bit_decimal):len()
    return tonumber(to_binary(flag_accumulator):sub(-flag_bit_pos,-flag_bit_pos)) or 0
end

function flag.get_bit(flag_accumulator, flag_bit_decimal)
    return math.floor(flag_accumulator / flag_bit_decimal) % 2
end

function flag.is_bit_true(flag_accumulator, flag_bit_decimal)
    return flag.get_bit(flag_accumulator, flag_bit_decimal) == 1
end

setmetatable(flag, {
    __call = function(_, ...)
        local flag_table = {}
        for i = 1, select('#',...) do
            local flag_bit = math.pow(2, i-1)
            flag_table[i] = flag_bit
            flag_table[select(i, ...)] = flag_bit
        end
        return flag_table
    end
})

return flag