local font = {}

local cache = {
    {} -- love basic font cache
}
local love_cache = cache[1]

function font.love(size)
    if not love_cache[size] then
        love_cache[size] = love.graphics.newFont(size)
    end
    return love_cache[size]
end

function font.get(font_path, size)
    if not cache[font_path] then
        cache[font_path] = {}
    end
    if not cache[font_path][size] then
        cache[font_path][size] = love.graphics.newFont(font_path, size)
    end
    return cache[font_path][size]
end

function font.print_upscaled_text(text, x, y, scale, font_size, font_path)
    local scaled_size = math.floor(scale * font_size + 0.5)
    local font_object = font_path and font.get(font_path, scaled_size) or font.love(scaled_size)

    love.graphics.print(text, font_object, x, y, 0, 1 / scale)
end

setmetatable(font, {
    __call = function(_, size) return font.love(size) end
})

return font