local box = require(PATH..'.gui.box')
local event = require(PATH..'.gui.event')
local style = require(PATH..'.gui.def.style')

local function new_button(text)
    local button = {
        box = box.new_box(),
        event_node = event.new_event_tree(),
        text = text or "Button",
    }
    button.box.width = 100
    button.box.height = 34
    button.box.draw_method = style.draw_button_text
    button.box.draw_options.text = button.text

    button.event_node.event_handler = function(e)
        if e.name == 'mouse_pressed' and e.target_box == button.box then
            button.box.draw_options.is_pressed = true
            --button.box.local_transform:setTransformation(0.5*button.box.width,0.5*button.box.height,0,0.9,0.9,0.5*button.box.width,0.5*button.box.height)
            --button.box.parent:layout_tree()
            event.catch_event(e)
        elseif e.name == 'mouse_released' then
            if button.box.draw_options.is_pressed and button.on_click then
                button.on_click()
            end
            button.box.draw_options.is_pressed = false
            --button.box.local_transform:reset()
            --button.box.parent:layout_tree()
        end
    end

    return button
end

return new_button