local widget = require(PATH..'.gui.widget')
local style = require(PATH..'.gui.default.style')

local function handler_method(self, event_data)
    local button = self.instance_data.widget

    if event_data:is("mousepressed") and event_data.button == 1 and button.box:is_box_at(event_data.x, event_data.y) then
        button.is_mouse_holding = true
    elseif event_data:is("mousereleased") then
        if button.is_mouse_holding and button.box:is_box_at(event_data.x, event_data.y) then
            if button.on_click then
                button.on_click()
            end
        end
        button.is_mouse_holding = false
    end
end

local function new(text)
    local button = widget.new()
    button.text = text or "button"
    button.event_handler.handler_method = handler_method
    button.box.draw_method = style.draw_button_text
    button.box.width, button.box.height = style.get_button_dimensions(button.text)
    return button
end

return {
    new = new,
}