local box = require(PATH..'.gui.box')
local event = require(PATH..'.gui.event')

local widget = {}

local Widget = {}
Widget.__index = Widget

function widget.new()
    local widget_instance = {
        box = box.new_box(),
        event_handler = event.new_event_handler(),
    }
    widget_instance.event_handler.instance_data.widget = widget_instance
    widget_instance.box.draw_options.widget = widget_instance
    setmetatable(widget_instance, Widget)
    return widget_instance
end

function widget.extend()
    local WidgetSubClass = {}
    WidgetSubClass.__index = WidgetSubClass
    setmetatable(WidgetSubClass, Widget)
    return WidgetSubClass
end

function Widget:draw()
    self.box:draw()
end

function Widget:update()
    self.event_handler:process_input()
end

return widget