local parse = {}

local function to_lua_helper(tbl, depth)
    local result = "{\n"
    local isempty = true

    for k, v in pairs(tbl) do
        -- Check the key type (ignore any numerical keys - assume its an array)
        local vtype = type(v)
        isempty = false

        if vtype ~= 'function' and vtype ~= 'userdata' then
            if type(k) == "string" then
                result = result..string.rep('\t',depth)..k.." = "
            else
                result = result..string.rep('\t',depth)
            end

            -- Check the value type
            if vtype == "table" then
                result = result..to_lua_helper(v, depth+1)
            elseif vtype == "boolean" then
                result = result..tostring(v)
            elseif vtype == "string" then
                result = result.."\'"..v.."\'"
            else
                result = result..v
            end
            result = result..",\n"
        end
    end
    -- Remove leading commas from the result
    if result ~= "{\n" then
        result = result:sub(1, result:len()-1)
    end
    return result..(isempty and "" or '\n')..string.rep('\t',depth-1).."}"
end

function parse.to_lua(tbl, humanize)
    return to_lua_helper(tbl, 1, humanize)
end

return parse