local pool = {}

function pool.set_limit(pool_table, table_count_limit)
    pool_table._pool_table_count_limit = table_count_limit
end

function pool.fetch(pool_table)
    if #pool_table > 0 then return table.remove(pool_table) end
    return {}
end

function pool.release(pool_table, used_table, do_clean)
    if pool_table._pool_table_count_limit and #pool_table == pool_table._pool_table_count_limit then return end
    if do_clean ~= false then
        for k in pairs(used_table) do used_table[k] = nil end
        setmetatable(used_table, nil)
    end
    table.insert(pool_table, used_table)
end

return pool