require("circle")
require("node")
require("line")
require("cable")
require("schema")
require("gui")
require("game")
require("nodes/emitter")
require("nodes/screen")
require("nodes/refractor")
require("nodes/attenuator")
require("nodes/combiner")
local Input = require("libraries/Input")
gamekit = require("libraries/gamekit")

local game

function love.load()
    input = Input()
    input:bind("mouse1", "pick")
    input:bind("a", "new emitter")
    input:bind("s", "new screen")
    input:bind("d", "new refractor")
    input:bind("f", "new attenuator")
    input:bind("g", "new combiner")
    input:bind("lctrl", "control")
    input:bind("rctrl", "control")
    input:bind("lalt", "delete")

    gamekit.gui.box.draw_wireframe_enabled = true

    love.graphics.setBackgroundColor(1,1,1)

    local test_schema = Schema()

    test_schema:add_node(EmitterNode(400, 100, test_schema))
    test_schema:add_node(AttenuatorNode(400, 225, test_schema))
    test_schema:add_node(RefractorNode(400, 375, test_schema))
    test_schema:add_node(ScreenNode(400, 500, test_schema))
    test_schema:connect(test_schema.nodes[1], test_schema.nodes[2])
    test_schema:connect(test_schema.nodes[2], test_schema.nodes[3])
    test_schema:connect(test_schema.nodes[3], test_schema.nodes[4])

    game = Game()
end

function love.update()
    game:update()
end

function love.draw()
    game:draw()
end