Node = Circle:extend()

Node.Radius = 30

function Node:new(x, y, schema)
    Circle.new(self, x, y, Node.Radius)
    self.schema = schema
    self.mouse_pick_x = 0
    self.mouse_pick_y = 0
    self.z = 0
    self.is_picked = false
    self.input_circle = Circle(self:get_input_x(), self:get_input_y(), 20)
    self.output_circle = Circle(self:get_output_x(), self:get_output_y(), 20)
end

function Node:get_max_inputs()
    return -1
end

function Node:get_max_outputs()
    return -1
end

function Node:get_input_x()
    return self.x
end

function Node:get_input_y()
    return self.y - Node.Radius - 15
end

function Node:get_output_x()
    return self.x
end

function Node:get_output_y()
    return self.y + Node.Radius + 15
end

function Node:get_output_color(r, g, b)
    return r, g, b
end

function Node:update()
    if input:pressed("pick") then
        if self:is_point_inside(love.mouse.getPosition()) and self.schema:is_not_obfuscated(self, love.mouse.getPosition()) then
            if input:down("delete") then
                self.schema:delete_node(self)
            else
                self.is_picked = true
                self.mouse_pick_x = love.mouse.getX() - self.x
                self.mouse_pick_y = love.mouse.getY() - self.y
                self.schema:put_on_top(self)
            end
        elseif self.schema:has_available_outputs(self) and self.output_circle:is_point_inside(love.mouse.getPosition()) then
            self.schema:start_wiring(self)
        end
    end
    if input:released("pick") then
        --if self.is_picked then
            --self.schema:adjust_node_position(self)
        --end
        self.is_picked = false
    end
    if self.is_picked then
        self.x = love.mouse.getX() - self.mouse_pick_x
        self.y = love.mouse.getY() - self.mouse_pick_y
    end

    self.input_circle:move_to(self:get_input_x(), self:get_input_y())
    self.output_circle:move_to(self:get_output_x(), self:get_output_y())

    if self.on_update then self:on_update() end
end

function Node:draw_body()
    love.graphics.setColor(1,1,1)
    self:draw_fill()
    love.graphics.setLineWidth(3)
    --if self.schema:is_overlapping_nodes(self) then
    --    love.graphics.setColor(0.8,0,0)
    --else
        love.graphics.setColor(0,0,0)
    --end
    self:draw_line()
end

function Node:draw()
    
    love.graphics.setLineWidth(2)
    if self.input_circle:is_point_inside(love.mouse.getPosition()) then
        if self.schema:has_available_inputs(self) then
            love.graphics.setColor(1,0.75,0.5)
        else
            love.graphics.setColor(0.7,0.7,0.7)
        end
        self.input_circle:draw_line()
    end

    if self.output_circle:is_point_inside(love.mouse.getPosition()) then
        if self.schema:has_available_outputs(self) then
            love.graphics.setColor(1,0.75,0.5)
        else
            love.graphics.setColor(0.7,0.7,0.7)
        end
        self.output_circle:draw_line()
    end
    

    self:draw_body()
end

function Node:__tostring()
    return "Node"
end