CombinerNode = Node:extend()

local text_font = love.graphics.newFont(30)
local text = love.graphics.newText(text_font, "+")

function CombinerNode:new(x, y, schema)
    Node.new(self, x, y, schema)
    self.channel = 1
end

function CombinerNode:get_output_color(...)
    local input_count = select("#", ...) / 3
    local out_r, out_g, out_b = 0, 0, 0
    local max_level = 0

    for i = 0, input_count-1 do
        local ir, ig, ib = select(i * 3 + 1, ...), select(i * 3 + 2, ...), select(i * 3 + 3, ...)
        out_r = out_r + ir
        out_g = out_g + ig
        out_b = out_b + ib
    end

    max_level = math.max(out_r, out_g, out_b)

    if max_level > 1 then
        out_r = out_r / max_level
        out_g = out_g / max_level
        out_b = out_b / max_level
    end

    return out_r, out_g, out_b
end

function CombinerNode:draw_body()
    Node.draw_body(self)

    love.graphics.setColor(0,0,0)
    love.graphics.draw(text, self.x - math.floor(0.5 * text:getWidth()), self.y - math.floor(0.5 * text:getHeight()))
end

function CombinerNode:__tostring()
    return "CombinerNode"
end

