ScreenNode = Node:extend()

function ScreenNode:new(x, y, schema)
    Node.new(self, x, y, schema)
    self.colored_circle = Circle(self.x, self.y, Node.Radius - 9)
end

function ScreenNode:get_max_inputs()
    return 1
end

function ScreenNode:get_max_outputs()
    return 0
end

function ScreenNode:on_update()
    self.colored_circle:move_to(self.x, self.y)
end

function ScreenNode:draw()
    Node.draw(self)
    love.graphics.setColor(0,0,0)
    love.graphics.setLineWidth(4)
    self.colored_circle:draw_line(30)
    love.graphics.setColor(self.schema:get_local_color(self))
    love.graphics.setLineWidth(2)
    self.colored_circle:draw_fill()
    love.graphics.setLineWidth(1)
    self.colored_circle:draw_line(30)
end

function ScreenNode:__tostring()
    return "ScreenNode"
end